/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.93 Revision 1.139
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.93 2011/08/22 04:46:32 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.139 2012/11/12 09:28:53 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 3|4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 49if version_is_at_least 4.8; then
22 IUSE="+exceptions" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
23else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 52fi
26 53
27HOMEPAGE="http://qt.nokia.com/" 54DEPEND="virtual/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
29 56 DEPEND+=" dev-lang/perl"
30LICENSE="|| ( LGPL-2.1 GPL-3 )" 57fi
31IUSE+=" debug pch aqua"
32 58
33RDEPEND=" 59RDEPEND="
34 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
35 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
36 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
37 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
38 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
39 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
40 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
41 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
42 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
43 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
44 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
45 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
46 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
47 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
48 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
49 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
50 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
51 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
52 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
53 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
54 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
55 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
56 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
57 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
58 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
59 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
60 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
61 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
62 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
63 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
64" 96"
65 97
66S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
67 99
68# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 101# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73
74 # Protect users by not allowing downgrades between releases 104 # Protect users by not allowing downgrades between releases.
75 # Downgrading revisions within the same release should be allowed 105 # Downgrading revisions within the same release should be allowed.
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then 106 if has_version ">${CATEGORY}/${P}-r9999:4"; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 107 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
78 eerror "Sanity check to keep you from breaking your system:" 108 eerror " *** Sanity check to keep you from breaking your system ***"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror "Downgrading Qt is completely unsupported and will break your system!"
80 die "aborting to save your system" 110 die "aborting to save your system"
81 else 111 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 112 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 113 fi
84 fi
85
86 if [[ "${PN}" == "qt-webkit" ]]; then
87 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
93 ewarn "For more info check out bug #307861"
94 echo
95 fi
96 eshopts_pop
97 fi 114 fi
98 115
99 PATH="${S}/bin${PATH:+:}${PATH}" 116 PATH="${S}/bin${PATH:+:}${PATH}"
100 if [[ ${CHOST} != *-darwin* ]]; then 117 if [[ ${CHOST} != *-darwin* ]]; then
101 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 118 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
106 # avoid extract failure. 123 # avoid extract failure.
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 124 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 125 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 126 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 127 fi
111
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!"
122 fi
123} 128}
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DEFAULT_UNSET
132# @DESCRIPTION:
133# Space-separated list including the directories that will be extracted from
134# Qt tarball.
124 135
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 136# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
137# @DEFAULT_UNSET
126# @DESCRIPTION: 138# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 139# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 140# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt
133# tarball
134 141
135# @FUNCTION: qt4-build_src_unpack 142# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 143# @DESCRIPTION:
137# Unpacks the sources 144# Unpacks the sources.
138qt4-build_src_unpack() { 145qt4-build_src_unpack() {
139 setqtenv 146 setqtenv
140 local unpack_p="${MY_P}" 147
141 case "${PV}" in 148 if ! version_is_at_least 4.1 $(gcc-version); then
142 4.8.0_beta*) 149 ewarn "Using a GCC version lower than 4.1 is not supported."
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 150 fi
151
152 if [[ ${PN} == qt-webkit ]]; then
153 eshopts_push -s extglob
154 if is-flagq '-g?(gdb)?([1-9])'; then
155 echo
156 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
157 ewarn "You may experience really long compilation times and/or increased memory usage."
158 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
159 ewarn "For more info check out https://bugs.gentoo.org/307861"
160 echo
161 fi
162 eshopts_pop
163 fi
164
165 case ${QT4_BUILD_TYPE} in
166 live)
167 git-2_src_unpack
144 ;; 168 ;;
169 release)
170 local tarball="${MY_P}.tar.gz" target= targets=
171 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
172 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
173 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
174 do
175 targets+="${MY_P}/${target} "
176 done
177
178 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
179 tar -xzf "${DISTDIR}/${tarball}" ${targets}
180 eend $? || die "failed to unpack"
181 ;;
145 esac 182 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
149 ${QT4_EXTRACT_DIRECTORIES}; do
150 targets+=" ${unpack_p}/${target}"
151 done
152
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
155 case "${PV}" in
156 4.8.0_beta*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 183}
162 184
163# @ECLASS-VARIABLE: PATCHES 185# @ECLASS-VARIABLE: PATCHES
186# @DEFAULT_UNSET
164# @DESCRIPTION: 187# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 188# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 189# This variable is expected to be defined in global scope of ebuild.
167# example: 190# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 191# src_prepare() phase.
169# ${FILESDIR}"/mypatch2.patch"
170# 192#
193# @CODE
194# PATCHES=( "${FILESDIR}/mypatch.patch"
195# "${FILESDIR}/patches_folder/" )
196# @CODE
171 197
172# @FUNCTION: qt4-build_src_prepare 198# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 199# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 200# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 201# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 202qt4-build_src_prepare() {
177 setqtenv 203 setqtenv
178 cd "${S}" 204
179 205 if [[ ${QT4_BUILD_TYPE} == live ]]; then
180 # fix qt 4.7 regression that skips -fvisibility=hidden 206 QTDIR="." ./bin/syncqt || die "syncqt failed"
181 if version_is_at_least "4.7.0_beta1"; then
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi 207 fi
208
186 # fix libx11 dependency on non X packages 209 # avoid X11 dependency in non-gui packages
187 if version_is_at_least "4.7.0_beta2"; then
188 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
189 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
190 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
191 fi
192 212
193 if use aqua; then 213 if use aqua; then
194 # provide a proper macx-g++-64 214 # provide a proper macx-g++-64
195 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 215 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
196 216
197 sed -e '/^CONFIG/s:app_bundle::' \ 217 sed -e '/^CONFIG/s:app_bundle::' \
198 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 218 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
199 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 219 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
200 fi 220 fi
201 221
202 if [[ ${PN} != qt-core ]]; then 222 if [[ ${PN} != qt-core ]]; then
203 skip_qmake_build_patch 223 skip_qmake_build
204 skip_project_generation_patch 224 skip_project_generation
205 symlink_binaries_to_buildtree 225 symlink_binaries_to_buildtree
206 fi 226 fi
207 227
208 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 228 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
209 # qmake bus errors with -O2 but -O3 works 229 # qmake bus errors with -O2 or -O3 but -O1 works
230 # Bug 373061
210 replace-flags -O2 -O3 231 replace-flags -O[23] -O1
211 fi 232 fi
212 233
213 # Bug 178652 234 # Bug 178652
214 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 235 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
215 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 236 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
216 append-flags -fno-gcse 237 append-flags -fno-gcse
217 fi 238 fi
218 239
240 if use_if_iuse c++0x; then
241 append-cxxflags -std=c++0x
242 fi
243
219 # Unsupported old gcc versions - hardened needs this :( 244 # Unsupported old gcc versions - hardened needs this :(
220 if [[ $(gcc-major-version) -lt 4 ]] ; then 245 if [[ $(gcc-major-version) -lt 4 ]]; then
221 ewarn "Appending -fno-stack-protector to CXXFLAGS" 246 ewarn "Appending -fno-stack-protector to CXXFLAGS"
222 append-cxxflags -fno-stack-protector 247 append-cxxflags -fno-stack-protector
223 # Bug 253127 248 # Bug 253127
224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 249 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
225 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 250 -i mkspecs/common/g++.conf || die
226 fi 251 fi
227 252
228 # Bug 261632 253 # Bug 261632
229 if use ppc64; then 254 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 255 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc 256 append-flags -mminimal-toc
232 fi 257 fi
233 258
234 # Bug 282984 && Bug 295530 259 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 260 sed -e "/^SYSTEM_VARIABLES=/i \
236 -i configure || die "sed qmake compilers failed" 261 CC='$(tc-getCC)'\n\
237 # bug 321335 262 CXX='$(tc-getCXX)'\n\
263 CFLAGS='${CFLAGS}'\n\
264 CXXFLAGS='${CXXFLAGS}'\n\
265 LDFLAGS='${LDFLAGS}'\n\
266 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
267 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
268 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
269 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
270 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
272 -i configure \
273 || die "sed SYSTEM_VARIABLES failed"
274
275 # Respect CC, CXX, LINK and *FLAGS in config.tests
276 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
277 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
278 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
279 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
280 || die "sed config.tests failed"
281
238 if version_is_at_least 4.6; then 282 if ! version_is_at_least 4.8; then
239 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 283 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
240 xargs -0 \ 284 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
241 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
242 -i || die "sed test compilers failed"
243 fi 285 fi
244 286
245 # Bug 172219 287 # Bug 172219
246 sed -e "s:X11R6/::" \ 288 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
247 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
248 289
249 if [[ ${CHOST} == *-darwin* ]]; then 290 if [[ ${CHOST} == *-darwin* ]]; then
250 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 291 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
251 # crippled (by design) :/ 292 # crippled (by design) :/
293 local mac_gpp_conf=
294 if [[ -f mkspecs/common/mac-g++.conf ]]; then
295 # qt < 4.8 has mac-g++.conf
296 mac_gpp_conf="mkspecs/common/mac-g++.conf"
297 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
298 # qt >= 4.8 has g++-macx.conf
299 mac_gpp_conf="mkspecs/common/g++-macx.conf"
300 else
301 die "no known conf file for mac found"
302 fi
303 sed \
252 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 304 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
253 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 305 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
254 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 306 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
255 -e "s:-arch\s\w*::g" \ 307 -e "s:-arch\s\w*::g" \
256 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 308 -i ${mac_gpp_conf} \
309 || die "sed ${mac_gpp_conf} failed"
257 310
258 # Fix configure's -arch settings that appear in qmake/Makefile and also 311 # Fix configure's -arch settings that appear in qmake/Makefile and also
259 # fix arch handling (automagically duplicates our -arch arg and breaks 312 # fix arch handling (automagically duplicates our -arch arg and breaks
260 # pch). Additionally disable Xarch support. 313 # pch). Additionally disable Xarch support.
314 local mac_gcc_confs="${mac_gpp_conf}"
315 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
316 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
317 fi
261 sed \ 318 sed \
262 -e "s:-arch i386::" \ 319 -e "s:-arch i386::" \
263 -e "s:-arch ppc::" \ 320 -e "s:-arch ppc::" \
264 -e "s:-arch x86_64::" \ 321 -e "s:-arch x86_64::" \
265 -e "s:-arch ppc64::" \ 322 -e "s:-arch ppc64::" \
266 -e "s:-arch \$i::" \ 323 -e "s:-arch \$i::" \
267 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 324 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
268 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 325 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
269 -e "s:-Xarch_x86_64::g" \ 326 -e "s:-Xarch_x86_64::g" \
270 -e "s:-Xarch_ppc64::g" \ 327 -e "s:-Xarch_ppc64::g" \
271 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 328 -i configure ${mac_gcc_confs} \
329 || die "sed -arch/-Xarch failed"
272 330
273 # On Snow Leopard don't fall back to 10.5 deployment target. 331 # On Snow Leopard don't fall back to 10.5 deployment target.
274 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 332 if [[ ${CHOST} == *-apple-darwin10 ]]; then
275 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 333 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
276 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 334 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
277 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 335 -i configure ${mac_gpp_conf} \
336 || die "sed deployment target failed"
278 fi 337 fi
279 fi 338 fi
280 339
281 # this one is needed for all systems with a separate -liconv, apart from 340 # this one is needed for all systems with a separate -liconv, apart from
282 # Darwin, for which the sources already cater for -liconv 341 # Darwin, for which the sources already cater for -liconv
283 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 342 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
284 sed \ 343 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
285 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
286 -i config.tests/unix/iconv/iconv.pro \ 344 -i config.tests/unix/iconv/iconv.pro \
287 || die "sed on iconv.pro failed" 345 || die "sed iconv.pro failed"
288 fi 346 fi
289 347
290 # we need some patches for Solaris 348 # we need some patches for Solaris
291 sed -i \
292 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 349 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
293 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 350 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
294 # use GCC over SunStudio 351 # use GCC over SunStudio
295 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 352 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
296 # don't flirt with non-Prefix stuff, we're quite possessive 353 # do not flirt with non-Prefix stuff, we're quite possessive
297 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 354 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
298 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 355 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
299 # strip predefined CFLAGS from qmake ( bug #312689 )
300 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
301 356
302 base_src_prepare 357 # apply patches
358 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
359 epatch_user
303} 360}
304 361
305# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
306# @DESCRIPTION: 363# @DESCRIPTION:
307# Default configure phase 364# Default configure phase
308qt4-build_src_configure() { 365qt4-build_src_configure() {
309 setqtenv 366 setqtenv
310 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 -importdir ${QTIMPORTDIR}
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable rpath on Qt >= 4.8 (bug 380415)
415 # but leave it enabled on prefix (bug 417169)
416 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
417
418 # precompiled headers don't work on hardened, where the flag is masked
419 conf+=" $(qt_use pch)"
420
421 # -reduce-relocations
422 # This flag seems to introduce major breakage to applications,
423 # mostly to be seen as a core dump with the message "QPixmap: Must
424 # construct a QApplication before a QPaintDevice" on Solaris.
425 # -- Daniel Vergien
426 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
311 427
312 # this one is needed for all systems with a separate -liconv, apart from 428 # this one is needed for all systems with a separate -liconv, apart from
313 # Darwin, for which the sources already cater for -liconv 429 # Darwin, for which the sources already cater for -liconv
314 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 430 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
315 myconf+=" -liconv" 431 conf+=" -liconv"
432 fi
316 433
317 if has glib ${IUSE//+} && use glib; then 434 if use_if_iuse glib; then
318 # use -I, -L and -l from configure
319 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 435 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
320 # avoid the -pthread argument 436 # avoid the -pthread argument
321 myconf+=" ${glibflags//-pthread}" 437 conf+=" ${glibflags//-pthread}"
322 unset glibflags 438 unset glibflags
323 fi 439 fi
324 440
441 if use_if_iuse qpa; then
442 echo
443 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
444 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
445 ewarn "disable it before reporting any bugs related to this useflag."
446 echo
447 conf+=" -qpa"
448 fi
449
325 if use aqua ; then 450 if use aqua; then
326 # On (snow) leopard use the new (frameworked) cocoa code. 451 # On (snow) leopard use the new (frameworked) cocoa code.
327 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 452 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
328 myconf+=" -cocoa -framework" 453 conf+=" -cocoa -framework"
454 # We need the source's headers, not the installed ones.
455 conf+=" -I${S}/include"
456 # Add hint for the framework location.
457 conf+=" -F${QTLIBDIR}"
329 458
330 # We are crazy and build cocoa + qt3support :-) 459 # We are crazy and build cocoa + qt3support :-)
331 if use qt3support; then 460 if use qt3support; then
332 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 461 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
333 -i configure 462 -i configure || die
334 fi 463 fi
335 464 else
336 # We need the source's headers, not the installed ones. 465 conf+=" -no-framework"
337 myconf+=" -I${S}/include"
338
339 # Add hint for the framework location.
340 myconf+=" -F${QTLIBDIR}"
341 fi 466 fi
342 else 467 else
343 # freetype2 include dir is non-standard, thus include it on configure 468 # freetype2 include dir is non-standard, thus pass it to configure
344 # use -I from configure
345 myconf+=" $(pkg-config --cflags freetype2)" 469 conf+=" $(pkg-config --cflags-only-I freetype2)"
346 fi 470 fi
347 471
348 # Disable SSE4.x, since auto-detection is currently broken 472 conf+=" ${myconf}"
349 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 473 myconf=
350 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
351 474
352 echo ./configure ${myconf} 475 echo ./configure ${conf}
353 ./configure ${myconf} || die "./configure failed" 476 ./configure ${conf} || die "./configure failed"
354 myconf=""
355 477
356 prepare_directories ${QT4_TARGET_DIRECTORIES} 478 prepare_directories ${QT4_TARGET_DIRECTORIES}
357} 479}
358 480
359# @FUNCTION: qt4-build_src_compile 481# @FUNCTION: qt4-build_src_compile
367 489
368# @FUNCTION: qt4-build_src_test 490# @FUNCTION: qt4-build_src_test
369# @DESCRIPTION: 491# @DESCRIPTION:
370# Runs tests only in target directories. 492# Runs tests only in target directories.
371qt4-build_src_test() { 493qt4-build_src_test() {
494 # QtMultimedia does not have any test suite (bug #332299)
495 [[ ${PN} == qt-multimedia ]] && return
496
372 for dir in ${QT4_TARGET_DIRECTORIES}; do 497 for dir in ${QT4_TARGET_DIRECTORIES}; do
373 emake -j1 check -C ${dir} 498 emake -j1 check -C ${dir}
374 done 499 done
375} 500}
376 501
377# @FUNCTION: fix_includes 502# @FUNCTION: fix_includes
378# @DESCRIPTION: 503# @DESCRIPTION:
379# For MacOSX we need to add some symlinks when frameworks are 504# For MacOS X we need to add some symlinks when frameworks are
380# being used, to avoid complications with some more or less stupid packages. 505# being used, to avoid complications with some more or less stupid packages.
381fix_includes() { 506fix_includes() {
382 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 507 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
508 local frw dest f h rdir
383 # Some packages tend to include <Qt/...> 509 # Some packages tend to include <Qt/...>
384 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 510 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
385 511
386 # Fake normal headers when frameworks are installed... eases life later on 512 # Fake normal headers when frameworks are installed... eases life later
387 local dest f 513 # on, make sure we use relative links though, as some ebuilds assume
514 # these dirs exist in src_install to add additional files
515 f=${QTHEADERDIR}
516 h=${QTLIBDIR}
517 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
518 f=${f#*/}
519 h=${h#*/}
520 done
521 rdir=${h}
522 f="../"
523 while [[ ${h} == */* ]] ; do
524 f="${f}../"
525 h=${h#*/}
526 done
527 rdir="${f}${rdir}"
528
388 for frw in "${D}${QTLIBDIR}"/*.framework; do 529 for frw in "${D}${QTLIBDIR}"/*.framework; do
389 [[ -e "${frw}"/Headers ]] || continue 530 [[ -e "${frw}"/Headers ]] || continue
390 f=$(basename ${frw}) 531 f=$(basename ${frw})
391 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 532 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
392 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 533 dosym "${rdir}"/${f}/Headers "${dest}"
393 534
394 # Link normal headers as well. 535 # Link normal headers as well.
395 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 536 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
396 h=$(basename ${hdr}) 537 h=$(basename ${hdr})
397 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 538 dosym "../${rdir}"/${f}/Headers/${h} \
539 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
398 done 540 done
399 done 541 done
400 fi 542 fi
401} 543}
402 544
403# @FUNCTION: qt4-build_src_install 545# @FUNCTION: qt4-build_src_install
404# @DESCRIPTION: 546# @DESCRIPTION:
405# Perform the actual installation including some library fixes. 547# Perform the actual installation including some library fixes.
406qt4-build_src_install() { 548qt4-build_src_install() {
407 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
408 setqtenv 549 setqtenv
550
409 install_directories ${QT4_TARGET_DIRECTORIES} 551 install_directories ${QT4_TARGET_DIRECTORIES}
410 install_qconfigs 552 install_qconfigs
411 fix_library_files 553 fix_library_files
412 fix_includes 554 fix_includes
555
413 # remove .la files since we are building only shared Qt libraries 556 # remove .la files since we are building only shared libraries
414 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 557 prune_libtool_files
415} 558}
416 559
417# @FUNCTION: setqtenv 560# @FUNCTION: setqtenv
561# @INTERNAL
418setqtenv() { 562setqtenv() {
419 # Set up installation directories 563 # Set up installation directories
420 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
421 QTPREFIXDIR=${EPREFIX}/usr 564 QTPREFIXDIR=${EPREFIX}/usr
422 QTBINDIR=${EPREFIX}/usr/bin 565 QTBINDIR=${QTPREFIXDIR}/bin
423 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 566 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
424 QMAKE_LIBDIR_QT=${QTLIBDIR}
425 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 567 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
426 QTDATADIR=${EPREFIX}/usr/share/qt4
427 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 568 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
428 QTHEADERDIR=${EPREFIX}/usr/include/qt4 569 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
429 QTPLUGINDIR=${QTLIBDIR}/plugins 570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${QTPREFIXDIR}/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
430 QTSYSCONFDIR=${EPREFIX}/etc/qt4 574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
431 QTTRANSDIR=${QTDATADIR}/translations
432 QTEXAMPLESDIR=${QTDATADIR}/examples 575 QTEXAMPLESDIR=${QTDATADIR}/examples
433 QTDEMOSDIR=${QTDATADIR}/demos 576 QTDEMOSDIR=${QTDATADIR}/demos
434 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 577 QMAKE_LIBDIR_QT=${QTLIBDIR}
578
435 PLATFORM=$(qt_mkspecs_dir) 579 PLATFORM=$(qt_mkspecs_dir)
436
437 unset QMAKESPEC 580 unset QMAKESPEC
438}
439 581
440# @FUNCTION: standard_configure_options 582 export XDG_CONFIG_HOME="${T}"
441# @DESCRIPTION:
442# Sets up some standard configure options, like libdir (if necessary), whether
443# debug info is wanted or not.
444standard_configure_options() {
445 local myconf=
446
447 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
448
449 # Disable visibility explicitly if gcc version isn't 4
450 if [[ $(gcc-major-version) -lt 4 ]]; then
451 myconf+=" -no-reduce-exports"
452 fi
453
454 # precompiled headers doesn't work on hardened, where the flag is masked.
455 myconf+=" $(qt_use pch)"
456
457 if use debug; then
458 myconf+=" -debug"
459 else
460 myconf+=" -release"
461 fi
462 myconf+=" -no-separate-debug-info"
463
464 use aqua && myconf+=" -no-framework"
465
466 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
467 # $(tc-arch). Therefore we convert it to supported values.
468 case "$(tc-arch)" in
469 amd64|x64-*) myconf+=" -arch x86_64" ;;
470 ppc-macos) myconf+=" -arch ppc" ;;
471 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
472 sparc|sparc-*) myconf+=" -arch sparc" ;;
473 x86-macos) myconf+=" -arch x86" ;;
474 x86|x86-*) myconf+=" -arch i386" ;;
475 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
476 hppa|sh) myconf+=" -arch generic" ;;
477 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
478 esac
479
480 # 4.5: build everything but qt-xmlpatterns w/o exceptions
481 # 4.6: exceptions USE flag
482 local exceptions="-exceptions"
483 case "${PV}" in
484 4.5.*)
485 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
486 ;;
487 *)
488 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
489 ;;
490 esac
491
492 # note about -reduce-relocations:
493 # That flag seems to introduce major breakage to applications,
494 # mostly to be seen as a core dump with the message "QPixmap: Must
495 # construct a QApplication before a QPaintDevice" on Solaris
496 # -- Daniel Vergien
497 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
498
499 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
500 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
501 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
502 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
503 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
504 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
505 ${exceptions}
506 -nomake examples -nomake demos"
507
508 echo "${myconf}"
509} 583}
510 584
511# @FUNCTION: prepare_directories 585# @FUNCTION: prepare_directories
512# @USAGE: < directories > 586# @USAGE: < directories >
587# @INTERNAL
513# @DESCRIPTION: 588# @DESCRIPTION:
514# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 589# Generates Makefiles for the given list of directories.
515prepare_directories() { 590prepare_directories() {
591 # avoid running over the maximum argument number, bug #299810
592 {
593 echo "${S}"/mkspecs/common/*.conf
594 find "${S}" -name '*.pr[io]'
595 } | xargs sed -i \
596 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
597 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
598 || die
599
516 for x in "$@"; do 600 for x in "$@"; do
517 pushd "${S}"/${x} >/dev/null 601 pushd "${S}"/${x} >/dev/null || die
518 einfo "running qmake in: $x" 602 einfo "Running qmake in: ${x}"
519 # avoid running over the maximum argument number, bug #299810 603 "${S}"/bin/qmake \
520 { 604 "LIBS+=-L${QTLIBDIR}" \
521 echo "${S}"/mkspecs/common/*.conf 605 "CONFIG+=nostrip" \
522 find "${S}" -name '*.pr[io]' 606 || die "qmake failed"
523 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
524 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
525 popd >/dev/null 607 popd >/dev/null || die
526 done 608 done
527} 609}
528
529 610
530# @FUNCTION: build_directories 611# @FUNCTION: build_directories
531# @USAGE: < directories > 612# @USAGE: < directories >
613# @INTERNAL
532# @DESCRIPTION: 614# @DESCRIPTION:
533# Compiles the code in $QT4_TARGET_DIRECTORIES 615# Compiles the code in the given list of directories.
534build_directories() { 616build_directories() {
535 for x in "$@"; do 617 for x in "$@"; do
536 pushd "${S}"/${x} >/dev/null 618 pushd "${S}"/${x} >/dev/null || die
619 emake \
620 AR="$(tc-getAR) cqs" \
537 emake CC="$(tc-getCC)" \ 621 CC="$(tc-getCC)" \
538 CXX="$(tc-getCXX)" \ 622 CXX="$(tc-getCXX)" \
539 LINK="$(tc-getCXX)" || die "emake failed" 623 LINK="$(tc-getCXX)" \
624 RANLIB=":" \
625 STRIP=":" \
626 || die "emake failed"
540 popd >/dev/null 627 popd >/dev/null || die
541 done 628 done
542} 629}
543 630
544# @FUNCTION: install_directories 631# @FUNCTION: install_directories
545# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
546# @DESCRIPTION: 634# @DESCRIPTION:
547# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
548install_directories() { 636install_directories() {
549 for x in "$@"; do 637 for x in "$@"; do
550 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
551 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
552 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
553 done 641 done
554} 642}
555 643
556# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
557# @DESCRIPTION: 645# @DESCRIPTION:
567# @DESCRIPTION: 655# @DESCRIPTION:
568# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
569: ${QCONFIG_DEFINE:=} 657: ${QCONFIG_DEFINE:=}
570 658
571# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
572# @DESCRIPTION: 661# @DESCRIPTION:
573# Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
574install_qconfigs() { 663install_qconfigs() {
575 local x 664 local x
576 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
577 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
578 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
589 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
590 fi 679 fi
591} 680}
592 681
593# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
683# @INTERNAL
594# @DESCRIPTION: 684# @DESCRIPTION:
595# Generates gentoo-specific configurations 685# Generates gentoo-specific qconfig.{h,pri}.
596generate_qconfigs() { 686generate_qconfigs() {
597 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
598 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
599 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
600 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
601 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
602 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
649 fi 739 fi
650} 740}
651 741
652# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
653# @DESCRIPTION: 743# @DESCRIPTION:
654# Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
655qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
656 generate_qconfigs 746 generate_qconfigs
657} 747}
658 748
659# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
660# @DESCRIPTION: 750# @DESCRIPTION:
661# Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
662# breakages and proposed solutions. 752# breakages and proposed solutions.
663qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
664 generate_qconfigs 754 generate_qconfigs
665} 755}
666 756
667# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
668# @DESCRIPTION: 759# @DESCRIPTION:
669# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
670skip_qmake_build_patch() { 761skip_qmake_build() {
671 # Don't need to build qmake, as it's already installed from qt-core
672 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
673} 763}
674 764
675# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
676# @DESCRIPTION: 767# @DESCRIPTION:
677# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
678skip_project_generation_patch() { 769skip_project_generation() {
679 # Exit the script early by throwing in an exit before all of the .pro files are scanned
680 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
681 -i "${S}"/configure || die "Sed failed"
682} 771}
683 772
684# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
685# @DESCRIPTION: 775# @DESCRIPTION:
686# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
687# time
688symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
689 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
690 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
691 done 780 done
692} 781}
693 782
694# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
695# @DESCRIPTION: 785# @DESCRIPTION:
696# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
697# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
698fix_library_files() { 788fix_library_files() {
789 local libfile
699 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
700 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
701 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
702 fi 793 fi
703 done 794 done
704 795
705 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
706 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
707 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
708 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
709 800
710 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
711 dodir ${QTPCDIR#${EPREFIX}} 802 dodir ${QTPCDIR#${EPREFIX}}
712 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
713 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
714 fi 804 fi
715 done 805 done
716 806
717 # Don't install an empty directory 807 # Don't install an empty directory
718 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
719} 809}
720 810
721# @FUNCTION: qt_use 811# @FUNCTION: qt_use
722# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
723# @DESCRIPTION: 813# @DESCRIPTION:
724# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
725# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
726# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
727# assignment-part 817# "-${enableval}" part.
728qt_use() { 818qt_use() {
729 local flag=$1 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
730 local feature=$1
731 local enableval=
732
733 [[ -n $2 ]] && feature=$2
734 [[ -n $3 ]] && enableval=-$3
735
736 if use ${flag}; then
737 echo "${enableval}-${feature}"
738 else
739 echo "-no-${feature}"
740 fi
741} 820}
742 821
743# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
744# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
745# @DESCRIPTION: 824# @DESCRIPTION:
746# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
747qt_mkspecs_dir() { 826qt_mkspecs_dir() {
748 # Allows us to define which mkspecs dir we want to use.
749 local spec 827 local spec=
750 828
751 case ${CHOST} in 829 case "${CHOST}" in
752 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
753 spec=freebsd ;; 831 spec=freebsd ;;
754 *-openbsd*) 832 *-openbsd*)
755 spec=openbsd ;; 833 spec=openbsd ;;
756 *-netbsd*) 834 *-netbsd*)
767 *-solaris*) 845 *-solaris*)
768 spec=solaris ;; 846 spec=solaris ;;
769 *-linux-*|*-linux) 847 *-linux-*|*-linux)
770 spec=linux ;; 848 spec=linux ;;
771 *) 849 *)
772 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
773 esac 851 esac
774 852
775 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
776 if [[ ${CXX} == *g++* ]]; then 854 *g++*)
777 spec+=-g++ 855 spec+=-g++ ;;
778 elif [[ ${CXX} == *icpc* ]]; then 856 *icpc*)
779 spec+=-icc 857 spec+=-icc ;;
780 else 858 *)
781 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
782 fi 860 esac
783 if [[ -n ${LIBDIR/lib} ]]; then
784 spec+=-${LIBDIR/lib}
785 fi
786 861
787 # Add -64 for 64bit profiles 862 # Add -64 for 64bit profiles
788 if use x64-freebsd || 863 if use x64-freebsd ||
789 use amd64-linux || 864 use amd64-linux ||
790 use x64-macos || 865 use x64-macos ||
795 fi 870 fi
796 871
797 echo "${spec}" 872 echo "${spec}"
798} 873}
799 874
800# @FUNCTION: qt_assistant_cleanup
801# @RETURN: nothing
802# @DESCRIPTION:
803# Tries to clean up tools.pro for qt-assistant ebuilds
804# Meant to be called in src_prepare
805qt_assistant_cleanup() {
806 # different versions (and branches...) may need different handling,
807 # add a case if you need special handling
808 case "${MY_PV_EXTRA}" in
809 *kde-qt*)
810 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
811 -e "/mac/,/^embedded.*makeqpf$/d" \
812 -i tools/tools.pro || die "patching tools.pro failed"
813 ;;
814 *)
815 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
816 -e "/mac/,/^embedded.*makeqpf$/d" \
817 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
818 -i tools/tools.pro || die "patching tools.pro failed"
819 ;;
820 esac
821}
822
823# @FUNCTION: qt_nolibx11 875# @FUNCTION: qt_nolibx11
824# @RETURN: nothing 876# @INTERNAL
825# @DESCRIPTION: 877# @DESCRIPTION:
826# Ignore X11 tests for packages that don't need X libraries installed 878# Ignore X11 tests for packages that don't need X libraries installed.
827qt_nolibx11() { 879qt_nolibx11() {
828 einfo "removing X11 check to allow X-less compilation"
829 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 880 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
830 die "x11 check sed failed" 881 die "x11 check sed failed"
831} 882}
832 883
833EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 884EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.93  
changed lines
  Added in v.1.139

  ViewVC Help
Powered by ViewVC 1.1.20